use crate::crypt::rand;
use std::time::{SystemTime, UNIX_EPOCH};

pub struct Key8bit {
    pub k: u8,
}

impl Key8bit {
    pub fn new(key: u8) -> Key8bit {
        return Key8bit{
            k: key,
        }
    }

    pub fn new_random() -> Key8bit {
        return Key8bit{
            k: rand::rand_u16(SystemTime::now().duration_since(UNIX_EPOCH).unwrap().as_secs() as u16) as u8,
        }
    }

    pub fn as_bytes(&self) -> Vec<u8> {
        return vec!(self.k);
    }
}

#[cfg(test)]
mod tests {
    use crate::crypt::keys::Key8bit;

    #[test]
    fn test_key8bit_generation() {
        assert_eq!(Key8bit::new(255).k, 255);
        Key8bit::new_random();
    }
}