use crate::crypt::keys::Key8bit;

pub fn encrypt(plain: &mut [u8], key: &Key8bit) {
    for i in 0..plain.len() {
        plain[i] = plain[i] ^ key.k;
    }
}

pub fn decrypt(encrypted: &mut[u8], key: &Key8bit) {
    for i in 0..encrypted.len() {
        encrypted[i] = encrypted[i] ^ key.k;
    }
}

#[cfg(test)]
mod tests {
    use crate::crypt::keys::Key8bit;
    use crate::crypt::xor;

    #[test]
    fn test_xor() {
        let plaintext = "plain text 123";
        let mut plaintext_bytes: Vec<u8> = Vec::with_capacity(plaintext.bytes().len());
        for b in plaintext.bytes() {
            plaintext_bytes.push(b);
        } 

        let key = Key8bit::new(45);
    
        xor::encrypt(&mut plaintext_bytes, &key);    
        xor::decrypt(&mut plaintext_bytes, &key);

        assert_eq!(String::from_utf8_lossy(&plaintext_bytes), plaintext);
    }
}