// Versioning
pub const PROTOCOL_VERSION_1: u8 = 1;
pub const PROTOCOL_LATEST_VERSION: u8 = PROTOCOL_VERSION_1;

// Packets' IDs
pub const HANDSHAKE_PACKET_ID: u8 = 1;
pub const HANDSHAKE_ACCEPT_PACKET_ID: u8 = 2;
pub const CONNECTION_SHUTDOWN_PACKET_ID: u8 = 3;
pub const TEXT_PACKET_ID: u8 = 4;
pub const FILEINFO_PACKET_ID: u8 = 5;
pub const FILEDATA_PACKET_ID: u8 = 6;
pub const FILE_ACCEPT_PACKET_ID: u8 = 7;
pub const FILE_REJECT_PACKET_ID: u8 = 8;

// File chunk size
pub const CHUNK_SIZE: usize = 262_144; // 256 KB

// Encryption types
pub const ENCRYPTION_NO_ENCRYPTION: u8 = 0;
pub const ECRYPTION_XOR: u8 = 1;

#[derive(PartialEq, Eq, Debug)]
pub enum RunMode {
    SEND,
    RECEIVE,
}

#[derive(Debug)]
pub struct Packet {
    pub header: u8,
    pub contents: Vec<u8>,
}